<?php
/*
Plugin Name: 123 HTTP Transport
Plugin URI: http://schnurpsel.de/wordpress-plugins/123-http-transport/
Description: Ermöglicht das Deaktivieren von Methoden, die Worpress für HTTP-Requests verwendet (ab WP 2.7).
Author: Ingo Henze
Version: 0.10
Author URI: http://putzlowitsch.de/
*/ 
// Einstellungen für das Plugin

// Globale Daten
$plw123htp_transports = array(
	'curl' => array( 'name' => 'curl' , 'checked' => false, 'enabled' => true, 'text' => 'cURL' ),
	'streams' => array( 'name' => 'streams' , 'checked' => false, 'enabled' => true, 'text' => 'Streams' ),
	'fopen' => array( 'name' => 'fopen' , 'checked' => false, 'enabled' => true, 'text' => 'fopen' ),
	'fsockopen' => array( 'name' => 'fsockopen' , 'checked' => false, 'enabled' => true, 'text' => 'fsockopen' ),
	'exthttp' => array( 'name' => 'http_extension' , 'checked' => false, 'enabled' => true, 'text' => 'HTTP-Extension' )
);

// Einstellungen laden
$plw123htp_options = get_option( 'plw123htp_options' );
// noch keine vorhanden, dann mit Default-Werten vorbelegen
if( !is_array( $plw123htp_options ) ) {
	$plw123htp_options = array(	
		'use_exthttp'  => true,			// HTTP-Extension
		'use_curl'  => true,				// cURL
		'use_streams'  => true,			// Streams
		'use_fopen'  => true,				// fopen (PHP-Option 'allow_url_fopen')
		'use_fsockopen'  => true		// fsockopen
	);
}
// wenn vorhanden, gegebenenfalls fehlende mit Default-Werten vorbelegen
else {
	if( !array_key_exists( 'use_exthttp', $plw123htp_options ) )
		$plw123htp_options['use_exthttp'] = true;
	if( !array_key_exists( 'use_curl', $plw123htp_options ) )
		$plw123htp_options['use_curl'] = true;
	if( !array_key_exists( 'use_streams', $plw123htp_options ) )
		$plw123htp_options['use_streams'] = true;
	if( !array_key_exists( 'use_fopen', $plw123htp_options ) )
		$plw123htp_options['use_fopen'] = true;
	if( !array_key_exists( 'use_fsockopen', $plw123htp_options ) )
		$plw123htp_options['use_fsockopen'] = true;
}

function plw123htp_http_extension_check( $use ) {
	global $plw123htp_transports,$plw123htp_options;
	$id = 'exthttp';
	$option_name = 'use_'.$id;
	if( $plw123htp_transports[$id]['checked'] )
		return $use?$plw123htp_options[$option_name]:false;
	$plw123htp_transports[$id]['checked'] = true;
	return false;
}
function plw123htp_curl_check( $use ) {
	global $plw123htp_transports,$plw123htp_options;
	$id = 'curl';
	$option_name = 'use_'.$id;
	if( $plw123htp_transports[$id]['checked'] )
		return $use?$plw123htp_options[$option_name]:false;
	$plw123htp_transports[$id]['checked'] = true;
	return false;
}
function plw123htp_streams_check( $use ) {
	global $plw123htp_transports,$plw123htp_options;
	$id = 'streams';
	$option_name = 'use_'.$id;
	if( $plw123htp_transports[$id]['checked'] )
		return $use?$plw123htp_options[$option_name]:false;
	$plw123htp_transports[$id]['checked'] = true;
	return false;
}
function plw123htp_fopen_check( $use ) {
	global $plw123htp_transports,$plw123htp_options;
	$id = 'fopen';
	$option_name = 'use_'.$id;
	if( $plw123htp_transports[$id]['checked'] )
		return $use?$plw123htp_options[$option_name]:false;
	$plw123htp_transports[$id]['checked'] = true;
	return false;
}
function plw123htp_fsockopen_check( $use ) {
	global $plw123htp_transports,$plw123htp_options;
	$id = 'fsockopen';
	$option_name = 'use_'.$id;
	if( $plw123htp_transports[$id]['checked'] )
		return $use?$plw123htp_options[$option_name]:false;
	$plw123htp_transports[$id]['checked'] = true;
	return false;
}

function plw123htp_init() {
	global $plw123htp_transports,$plw123htp_options;
	
	foreach( $plw123htp_transports as $id => $transport ) {
		$option_name = 'use_'.$id;
		$transport['enabled'] = $plw123htp_options[$option_name];
		add_filter( 'use_'.$transport['name'].'_transport', 'plw123htp_'.$transport['name'].'_check' );
	}	
	if( WP_ADMIN == true )
		if( function_exists( '_wp_http_get_object' ) ) {
			$http = _wp_http_get_object();
		}
}

plw123htp_init();

// Admin-Panel
function plw123htp_options_subpanel() {
	global $plw123htp_transports,$plw123htp_options;
		
  if (isset($_POST['plw123htp_update'])) {
		// Optionen
		foreach( $plw123htp_transports as $id => $transport ) {
			if( $transport['checked'] ) {
				$option_name = 'use_'.$id;
				$form_name = 'plw123htp_opt_u'.substr( $id, 0, 2 );
				$plw123htp_options[$option_name] = isset($_POST[$form_name]);
			}
		}
		update_option('plw123htp_options', $plw123htp_options );
		
		
    ?><div class="updated"><p><strong>Einstellungen wurden gespeichert.</strong></p></div>
	<?php
  }
	
	$transport_options = '';
	foreach( $plw123htp_transports as $id => $transport ) {
		if( $transport['checked'] ) {
			$transport_count++;
			$option_name = 'use_'.$id;
			$form_name = 'plw123htp_opt_u'.substr( $id, 0, 2 );
			$label = $transport['text'];
			$checked = $plw123htp_options[$option_name]?" checked='checked'":'';
			$transport_options .= "<input type='checkbox' name='$form_name' value='1'$checked /><label> $label</label><br />\n";
		}
	}
	$plugindata = get_plugin_data( __FILE__, false, true );
	?>
	
<div class="wrap" style="height:100%">
    <h2><?php echo $plugindata['Title']; ?> Einstellungen</h2>
	<p>Plugin-Version <?php echo $plugindata['Version']; ?></p>
	<p><?php echo $plugindata['Description']; ?></p>
<?php
if( '' == $transport_options ) { ?>
<strong>Es sind keine geeigneten HTTP-Transport-Methoden vorhanden.</strong>
<?php }
else { ?>  <form method="post" id="plw123htp_optform" onsubmit="return createLists()">
	<h3>Optionen:</h3>
	<table cellspacing="2" cellpadding="5" class="editform form-table">
<tr valign="top"><th scope="row">HTTP-Transport erlauben mit</th>
<td>
<?php echo $transport_options; ?>
</td>
</tr>
	</table>
<div class="submit" style="clear:both;">
  <input type="submit" name="plw123htp_update" value="Einstellungen speichern »" />
</div>
  </form>
<?php } ?>
 </div><?php
}

function plw123htp_add_admin_panel() {
	if (function_exists('add_options_page')) {
		add_options_page('123 HTTP Transport', '123 HTTP Transport', 8, basename(__FILE__), 'plw123htp_options_subpanel');
    }
 }

add_action( 'admin_menu', 'plw123htp_add_admin_panel' );

?>